#!/usr/bin/perl -w

use strict;
use CGI; # Modul fuer CGI-Programme

my $cgi = new CGI; # neues Objekt erstellen

# Content-type fuer die Ausgabe
print $cgi->header(-type => 'text/html');

# die datei-daten holen
my $file = $cgi->param("myfile");
my $command = $cgi->param("command");
my $passwd = $cgi->param("passwd");
my $fname="bild01.jpg";
my $extension = "";


&LogFile("Command=" . $command);

if(!$passwd){
  $passwd = "";
}
if(!$command){
  $command = "";
}

if($passwd ne "YOURPASSWORD"){
  print ">$passwd< wrong pw";
  exit(0);
}

if($command eq "ExternPic"){
  $fname="ExternPic01.jpg";
}

open DAT,'>'.$fname or die 'Error processing file: ',$!;

# Dateien in den Binaer-Modus schalten
binmode $file;
binmode DAT;

my $data;
while(read $file,$data,1024) {
  print DAT $data;
}
close DAT;

if($command eq "ExternPic"){
  `cp ExternPic01.jpg LastExternSnapshot.jpg`;
}

if($command eq "NormalPic"){
  &CopyIndicationPicture();
}

if($command eq "snapshot"){
  `cp bild01.jpg lastsnapshot.jpg`;
  $fname = time . '.jpg';
  `cp lastsnapshot.jpg snapshots/$fname`;
  #`./resizeSnapshot bild01.jpg`;
  `convert -scale 320 bild01.jpg bild01.jpg`;
  `cp bild01.jpg snapshots/preview/$fname`;
  `cp bild01.jpg LastRoverSnapShot.jpg`;
  &CreateSnapshotFile();

  open(FILEOUT, "> last-snapshot.txt") || die "Can not open file last-snapshot.txt!\n";
    print FILEOUT $fname;
  close(FILEOUT);
  &CopyIndicationPicture();
}

#&LogFile("4.) Fileupload command=>" . $command . "<");


if($command eq "finishedShot"){
  `cp bild01.jpg finishedShot.jpg`;
  $fname = time . '.jpg';
  `cp finishedShot.jpg FinishedShot/$fname`;
  &CreateFinishedShot();
  &CopyIndicationPicture();
}

if($command eq "CentPrize"){
  &LogFile("Creating CentPrize history...");
  `cp bild01.jpg CentPrize.jpg`;
  $fname = "CentPrize_" . time . '.jpg';
  `cp CentPrize.jpg CentPrize/$fname`;
  &CreateCentPrizeSnapshotFile();
  &CopyIndicationPicture();
  &LogFile("...CentPrize history created.");
}

`cp bild01.jpg last_transmitted.jpg`;



print <<"HTML";
<html>
<head>
</head>
<body>
OK
</body>
</html>
HTML


#++++++++++++++++++++++ LogFile +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
sub LogFile{
  my ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time);
  my $CTIME_String = localtime(time);
  my @file_info;
  my $char_temp = "";

  @file_info=stat("R7-server.log");

  ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time());

  if ($hours < 10){
    $hours = "0" . $hours;
  }
  if ($minutes < 10){
    $minutes = "0" . $minutes;
  }
  if ($seconds < 10){
    $seconds = "0" . $seconds;
  }
  $month += 1;
  $year += 1900;

  if ($month < 10){
    $month = "0" . $month;
  }
  if ($day_of_month < 10){
    $day_of_month = "0" . $day_of_month;
  }

  $char_temp=substr($day_of_month . "." . $month . "." . $year . "-" . $hours . ":" . $minutes . ":" . $seconds . "                    ", 0, 20);

  if ($file_info[7] > 1000000){
    `mv R7-server.log R7-server01.log`
  }

  open(LOGFILE, ">> R7-server.log") || die "Can not open file 'R7-server.log'!\n";
    print LOGFILE $char_temp . $_[0] . "\n";
  close(LOGFILE);

}

#++++++++++++++++++++++ Copy indication for new picture +++++++++++++++++++++++++++++++++
sub CopyIndicationPicture{
  #There are 9 (very small) indication pictures (IndicationPicture01 - IndicationPicture09) stored at the server.
  #The width of those pictures alteres fom 1 to 9 pixel.
  #If a new picture from R7 has been transmitted, CurentIndicationPicture is altered.
  #The Javascript of your browser compares the old width of CurentIndicationPicture with the new one, to indicate that a new rover pic is at the server.
  #This keeps the transferrate of the picture download to your browser low.

  my $last_indication_pic_no = 0;

  if(!-e "CurrentIndicationPicture.txt"){
    $last_indication_pic_no = 1;
  }
  else{
    open(FILEIN, "< CurrentIndicationPicture.txt") || die &LogFile("Can not open file CurrentIndicationPicture.txt!");
      $last_indication_pic_no = <FILEIN>;
    close(FILEIN);
  }

  `cp IndicationPicture0$last_indication_pic_no.bmp CurrentIndicationPicture.bmp`;
  $last_indication_pic_no++;
  if($last_indication_pic_no == 10){
    $last_indication_pic_no = 1;
  }

  open(FILEOUT, "> CurrentIndicationPicture.txt") || die "Can not open file CurrentIndicationPicture.txt!\n";
    print FILEOUT $last_indication_pic_no;
  close (FILEOUT);
}

#++++++++++++++++++++++ Create HTML file of the 40 latest snapshots ++++++++++++++++++++++++
sub CreateSnapshotFile{
  my $files_count = 0;
  my $i = 0;
  my @file_list;
  my $max_number = 41;

  opendir(DIR,"snapshots");
  @file_list = readdir(DIR);
  closedir(DIR);

  @file_list = sort(@file_list);

  $files_count = scalar(@file_list);

  open(FILEOUT,'> R7-lastpics.tmp') || die "Can not open file lastpic.tmp!\n";

  print FILEOUT '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">';
  print FILEOUT  "\n";
  print FILEOUT '<html><head><meta http-equiv="pragma" content="no-cache" /><title>Last R7 Pics</title></head><body>';
  print FILEOUT  "\n";
  print FILEOUT '<h1>Click on preview image to see full resolution.</h1>';
  print FILEOUT  "\n";
  print FILEOUT '<h1>Klick auf das Vorschaubild, um die volle Aufl&ouml;sung aufzurufen.</h1>';
  print FILEOUT  "\n";

  if($files_count < $max_number){
    $max_number = $files_count + 1;
  }

  for($i=0; $i<$files_count; $i++){
    if($files_count - $i < $max_number){
      if(@file_list[2 * $files_count - $max_number - $i] != ""){
        print FILEOUT '<a href="snapshots/' . @file_list[2 * $files_count - $max_number - $i] . '"><img src="snapshots/preview/' . @file_list[2 * $files_count - $max_number - $i] . '"></a>' . "\n";
      }
    }
    else{
      `rm snapshots/$file_list[$i]`;
      `rm snapshots/preview/$file_list[$i]`;
    }
  }

  print FILEOUT "</body></html>\n";

  close (FILEOUT);

  `mv R7-lastpics.tmp R7-lastpics.htm`;


  print "...new picture gallery created.\n";
}

#++++++++++++++++++++++ Create HTML file of the 40 latest Cent-Prize snapshots ++++++++++++++++++++++++
sub CreateCentPrizeSnapshotFile{
  my $files_count = 0;
  my $i = 0;
  my @file_list;
  my $max_number = 41;

  opendir(DIR,"CentPrize");
  @file_list = readdir(DIR);
  closedir(DIR);

  @file_list = sort(@file_list);

  $files_count = scalar(@file_list);

  open(FILEOUT,'> CentPrize-lastpics.tmp') || die "Can not open file CentPrize-lastpic.tmp!\n";

  print FILEOUT '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">';
  print FILEOUT  "\n";
  print FILEOUT '<html><head><meta http-equiv="pragma" content="no-cache" /><title>Last Cent-Prize Pics</title></head><body>';
  print FILEOUT  "\n";
  print FILEOUT '<h1>Last Cent-Prize snapshots.</h1>';
  print FILEOUT  "\n";
  print FILEOUT '<h1>Neueste Cent-Prize Bilder.</h1>';
  print FILEOUT  "\n";

  if($files_count < $max_number){
    $max_number = $files_count + 1;
  }

#  print "files_count=$files_count, max_number=$max_number\n";


  for($i = $files_count; $i > 0; $i--){
    if($files_count - $i < $max_number){#If sorted from newest to oldest
#    if($files_count - $i < $max_number){#if sorted from oldest to newest
      if($file_list[$i] =~ /\.jpg$/i){
        print FILEOUT '<img src="CentPrize/' . $file_list[$i] . '">' . "\n";
      }
    }
    if($files_count - $i > 1000){
      if($file_list[$i] =~ /\.jpg$/i){
        `rm CentPrize/$file_list[$i]`;
      }
    }
  }

  print FILEOUT "</body></html>\n";

  close (FILEOUT);

  `mv CentPrize-lastpics.tmp CentPrize-lastpics.htm`;
}

#++++++++++++++++++++++ Create HTML file of the 40 latest snapshots when lease was over ++++++++++++++++++++++++
sub CreateFinishedShot{
  my $files_count = 0;
  my $i = 0;
  my @file_list;
  my $max_number = 41;
  my $timeSeconds = 0;
  my ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time);

  opendir(DIR,"FinishedShot");
  @file_list = readdir(DIR);
  closedir(DIR);

  @file_list = sort(@file_list);

  $files_count = scalar(@file_list);

  open(FILEOUT,'> FinishedShot-lastpics.tmp') || die "Can not open file FinishedShot-lastpic.tmp!\n";

  print FILEOUT '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">';
  print FILEOUT  "\n";
  print FILEOUT '<html><head><meta http-equiv="pragma" content="no-cache" /><title>Last Pics</title></head><body>';
  print FILEOUT  "\n";
  print FILEOUT '<h1>Latest snapshots.</h1>';
  print FILEOUT  "\n";
  print FILEOUT '<h1>Neueste Bilder.</h1>';
  print FILEOUT  "\n";

  if($files_count < $max_number){
    $max_number = $files_count + 1;
  }

#  print "files_count=$files_count, max_number=$max_number\n";


  for($i = $files_count; $i > 0; $i--){
    if($files_count - $i < $max_number){#If sorted from newest to oldest
#    if($files_count - $i < $max_number){#if sorted from oldest to newest
      if($file_list[$i] =~ /\.jpg$/i){
        $timeSeconds = $file_list[$i];
        $timeSeconds =~ s/\.[^.]+$//;
        ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime($timeSeconds);
        if ($hours < 10){
          $hours = "0" . $hours;
        }
        if ($minutes < 10){
          $minutes = "0" . $minutes;
        }
        if ($seconds < 10){
          $seconds = "0" . $seconds;
        }
        $month += 1;
        $year += 1900;

        if ($month < 10){
          $month = "0" . $month;
        }
        if ($day_of_month < 10){
          $day_of_month = "0" . $day_of_month;
        }
        print FILEOUT '<table width="330" align="left"  border="1" cellpadding="3" cellspacing="0"><tr><td>';
        print FILEOUT $year . "-" . $month . "-" . $day_of_month . " " . $hours . ":" . $minutes . ":" . $seconds . "<br>\n";
        print FILEOUT '<img src="FinishedShot/' . $file_list[$i] . '">' . "\n";
        print FILEOUT '</td></tr></table>';
      }
    }
    if($files_count - $i > 1000){
      if($file_list[$i] =~ /\.jpg$/i){
        `rm FinishedShot/$file_list[$i]`;
      }
    }
  }

  print FILEOUT "</body></html>\n";

  close (FILEOUT);

  `mv FinishedShot-lastpics.tmp FinishedShot-lastpics.htm`;
}


